if (typeof(SmartTextLinksOptions)=='undefined')
{
	var SmartTextLinksOptions =
	{
		prefs: null,

		getCountry: function()
		{
			var ios = Components.classes["@mozilla.org/network/io-service;1"]
	           	.getService(Components.interfaces.nsIIOService);
			var uri = ios.newURI(SmartTextLinksAddonConfig.baseUrl, null, null);
			var cookieSvc = Components.classes["@mozilla.org/cookieService;1"]
				.getService(Components.interfaces.nsICookieService);
			var cookie = cookieSvc.getCookieString(uri, null);
			if (cookie!=null && cookie!="")
			{
				var r = cookie.split(";");
				for (var i=0; i<r.length; i++)
				{
					var v = r[i].split("=");
					if (v[0].trim()=="sa_cc")
					{
						return v[1].trim();
					}
				}
			}
		},

		getAid: function()
		{
			var prefs = Components.classes["@mozilla.org/preferences-service;1"]
				.getService(Components.interfaces.nsIPrefService)
				.getBranch("extensions."+SmartTextLinksAddonConfig.name+".");
			prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
			var aid = (prefs.prefHasUserValue("aid")?prefs.getCharPref("aid"):null);
			var aidcheck = SmartTextLinksAddonConfig.aid;
			//if (!aid)
			{
				var ios = Components.classes["@mozilla.org/network/io-service;1"]
	            	.getService(Components.interfaces.nsIIOService);
				var uri = ios.newURI(SmartTextLinksAddonConfig.baseUrl, null, null);
				var cookieSvc = Components.classes["@mozilla.org/cookieService;1"]
					.getService(Components.interfaces.nsICookieService);
				var cookie = cookieSvc.getCookieString(uri, null);
				if (cookie!=null && cookie!="") 
				{
					var r = cookie.split(";");
					for (var i=0; i<r.length; i++)
					{
						var v = r[i].split("=");
						if (v[0].trim()=="aid")
						{
							var caid = v[1].trim();
							if (!aid || (aid && caid.indexOf(aid+'.')==0))
							{
								aid = caid;
								if (aidcheck!="" && (aid==null || (aidcheck!=aid && aid.indexOf(aidcheck+".")!=0)))
									aid = aidcheck;
								prefs.setCharPref("aid",aid);
							}
							break;
						}
					}
				}
			};
			if (aidcheck!="" && (aid==null || (aidcheck!=aid && aid.indexOf(aidcheck+".")!=0)))
			{
				prefs.setCharPref("aid",aidcheck);
				aid = aidcheck;
			}
			return aid;
		},

		init: function()
		{
			this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
				.getService(Components.interfaces.nsIPrefService)
				.getBranch("extensions."+SmartTextLinksAddonConfig.name+".");
			this.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
			window.setInterval(function(){SmartTextLinksOptions.timer();},1000);
    	},

		initOptionsDialog: function()
		{
			var aid = this.getAid();
			var url = SmartTextLinksAddonConfig.settingsUrl+"?ext&addon=Firefox";
			if (aid && aid!="")
				url += "&a=" + encodeURIComponent(aid);
			document.getElementById(SmartTextLinksAddonConfig.name.toLowerCase()+'-options-dialog-frame').setAttribute('src',url);
			window.setInterval(function(){SmartTextLinksOptions.timer2();},1000);
		},

		openSettingsPage: function()
		{
			this.showSettings();
		},

		processSettings: function(doc)
		{
			if (!doc)
				return;
			var el = doc.getElementById("sa-ffclose");
			if (el)
			{
				el.parentNode.removeChild(el);
				document.getElementById(SmartTextLinksAddonConfig.name.toLowerCase()+'-settings-popup').hidePopup();
			}
			el = doc.getElementById("sa-ffcloserefresh");
			if (el)
			{
				el.parentNode.removeChild(el);
				document.getElementById(SmartTextLinksAddonConfig.name.toLowerCase()+'-settings-popup').hidePopup();
				if (typeof(gBrowser)!="undefined" && gBrowser.selectedBrowser)
					gBrowser.selectedBrowser.reload();
			}
		},

		timer: function(e)
		{
			if (document.getElementById(SmartTextLinksAddonConfig.name.toLowerCase()+'-settings-frame'))
			{
				var doc = document.getElementById(SmartTextLinksAddonConfig.name.toLowerCase()+'-settings-frame').contentDocument;
				this.processSettings(doc);
			}
			if (typeof(gBrowser)!="undefined" && gBrowser.selectedBrowser)
			{
				var doc = gBrowser.selectedBrowser.contentDocument;
				this.processSettings(doc);
			}
		},

		timer2: function(e)
		{
			var doc = null;
			if (document.getElementById(SmartTextLinksAddonConfig.name.toLowerCase()+'-options-dialog-frame'))
				doc = document.getElementById(SmartTextLinksAddonConfig.name.toLowerCase()+'-options-dialog-frame').contentDocument;
			if (!doc)
				return;
			var el = doc.getElementById("sa-ffclose");
			if (el)
			{
				el.parentNode.removeChild(el);
				window.close();
			}
			el = doc.getElementById("sa-ffcloserefresh");
			if (el)
			{
				el.parentNode.removeChild(el);
				window.close();
			}
		},

		showSettings: function()
		{
			var browserDoc = gBrowser.selectedBrowser?gBrowser.selectedBrowser.contentDocument:null;
			if (browserDoc)
			{
				var el = browserDoc.getElementById("stextlinks-showsettings");
				if (el)
				{
					try{
						el.click();
						return;
					}catch(e){}
				}
			}
			var aid = this.getAid();
			var url = SmartTextLinksAddonConfig.settingsUrl + '?ext1&addon=Firefox';
			if (aid && aid!="")
				url += "&a=" + encodeURIComponent(aid);
			document.getElementById(SmartTextLinksAddonConfig.name.toLowerCase()+'-settings-frame').setAttribute('src','about:blank');
			document.getElementById(SmartTextLinksAddonConfig.name.toLowerCase()+'-settings-frame').setAttribute('src',url);
			document.getElementById(SmartTextLinksAddonConfig.name.toLowerCase()+'-settings-popup').openPopup(document.getElementById(SmartTextLinksAddonConfig.name.toLowerCase()+'-button'), 'after_end', 0, 0, false, false);
		},

		showAbout: function()
		{
			gBrowser.selectedTab = gBrowser.addTab(SmartTextLinksAddonConfig.aboutUrl);
		},

		showHomePage: function()
		{
			gBrowser.selectedTab = gBrowser.addTab(SmartTextLinksAddonConfig.homeUrl);
		},

		showContact: function()
		{
			gBrowser.selectedTab = gBrowser.addTab(SmartTextLinksAddonConfig.contactUrl);
		}
	};
	window.addEventListener("load", function(){SmartTextLinksOptions.init();}, false);
}
