(function(window) {
function Core () {
	var $ = this;
	$.Events = {
		load: function (e) {
			$._initializeOverlay(e);
		},

		unload: function() {
			$._unloadPlugin();
		}
	};
	$.NavigateListener = {};
	$._unloadPlugin = function UnloadPlugin() {
	};

	$.IsURL = function(text) {
		return ((text.indexOf("http://") == 0 || text.indexOf("https://") == 0 || text.indexOf("www.") == 0 || text.indexOf(" ") == -1)  && text.indexOf(".") != -1);
	};

	$.getAid = function()
	{
		var prefs = Components.classes["@mozilla.org/preferences-service;1"]
			.getService(Components.interfaces.nsIPrefService)
			.getBranch("extensions."+SmartTextLinksAddonConfig.name+".");
		prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
		var aid = (prefs.prefHasUserValue("aid")?prefs.getCharPref("aid"):null);
		var aidcheck = SmartTextLinksAddonConfig.aid;
		//if (!aid)
		{
			var ios = Components.classes["@mozilla.org/network/io-service;1"]
            	.getService(Components.interfaces.nsIIOService);
			var uri = ios.newURI(SmartTextLinksAddonConfig.baseUrl, null, null);
			var cookieSvc = Components.classes["@mozilla.org/cookieService;1"]
				.getService(Components.interfaces.nsICookieService);
			var cookie = cookieSvc.getCookieString(uri, null);
			if (cookie!=null && cookie!="") 
			{
				var r = cookie.split(";");
				for (var i=0; i<r.length; i++)
				{
					var v = r[i].split("=");
					if (v[0].trim()=="aid")
					{
						var caid = v[1].trim();
						if (!aid || (aid && caid.indexOf(aid+'.')==0))
						{
							aid = caid;
							if (aidcheck!="" && (aid==null || (aidcheck!=aid && aid.indexOf(aidcheck+".")!=0)))
								aid = aidcheck;
							prefs.setCharPref("aid",aid);
						}
						break;
					}
				}
			}
		};
		if (aidcheck!="" && (aid==null || (aidcheck!=aid && aid.indexOf(aidcheck+".")!=0)))
		{
			prefs.setCharPref("aid",aidcheck);
			aid = aidcheck;
		}
		return aid;
	};

	$._initializeOverlay = function(e) {
  	    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
			.getService(Components.interfaces.nsIPrefService)
			.getBranch("extensions."+SmartTextLinksAddonConfig.name+".");
		prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);

		var aid = $.getAid();

		$.Observer.addObserver({ observe: function(subject, topic, data) {
			let item = aSubject.QueryInterface(Components.interfaces.nsIUpdateItem)
			if (topic != "em-action-requested" || item == null)
				return;
			if (item.id != SmartTextLinksAddonConfig.GUID)
				return;
			 if (aData == "item-uninstalled") {
				var prefs = Components.classes["@mozilla.org/preferences-service;1"]
					.getService(Components.interfaces.nsIPrefService)
					.getBranch("extensions."+SmartTextLinksAddonConfig.name+".");
				prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
				prefs.deleteBranch("");
			 }
		}}, "em-action-requested", false);
		if (AddonManager)
		{
			AddonManager.addAddonListener($.AddonListener);
		}

		if(typeof(gBrowser)!="undefined") gBrowser.addEventListener("DOMContentLoaded", function(e)
		{
          	var doc = e.originalTarget;
          	var win = doc.defaultView;
        	if (win != win.top) return; //only top window.
        	if (win.frameElement) return; // skip iframes/frames
            if (doc.location != null && (doc.location.href.indexOf("http://") == 0 || (doc.location.href.indexOf("https://") == 0 && SmartTextLinksAddonConfig.supportsSSL())))
          	{
          		let xhr = new XMLHttpRequest();
          		xhr.open("GET", "chrome://"+SmartTextLinksAddonConfig.name.toLowerCase()+"/content/inject.js", true);
          		xhr.overrideMimeType('text/plain; charset=UTF-8');
          		xhr.addEventListener("load", function(e) {
          			if (e.target.readyState != 4)
          				return;
          			var script = doc.createElement("script");
          			var text = e.target.responseText;
					var aid = $.getAid();
          			if (aid && aid!="")
          			{
          				text = text.replace('";//#aidext#',escape(aid)+'";');
          			}
					text = text.replace('";//#url#',SmartTextLinksAddonConfig.scriptUrl+'";');
          			script.setAttribute("type", "text/javascript");
          			script.text = text;
          			var holder = doc.body;
          			if (!holder)
          				holder = doc.getElementsByTagName('head')[0];
          			if (holder)
          			{
          				holder.appendChild(script);
          				holder.removeChild(script);
          			}
          		}, false);
          		xhr.send();
          	}
		}, false);
	};

	$.Observer = Components.classes['@mozilla.org/observer-service;1'].
					getService(Components.interfaces.nsIObserverService);

	$.AddonListener = {
		onUninstalling: function(addon, needsRestart)
		{
			if (addon.id==SmartTextLinksAddonConfig.GUID)
			{
				var prefs = Components.classes["@mozilla.org/preferences-service;1"]
					.getService(Components.interfaces.nsIPrefService)
					.getBranch("extensions."+SmartTextLinksAddonConfig.name+".");
				prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
				prefs.deleteBranch("");
			}
		}
	};

};

var smarttextlinksCore = new Core();
window.addEventListener("load", function(aLoadEvent) 
{
	aLoadEvent.currentTarget.removeEventListener("load", arguments.callee, false);
	aLoadEvent.currentTarget.addEventListener("unload", function(aUnloadEvent) {
		aUnloadEvent.currentTarget.removeEventListener("unload", arguments.callee, false);
		suggestorCore.Events.unload(aUnloadEvent);
	}, false);
	smarttextlinksCore.Events.load(aLoadEvent);
}, false);

})(window);
